﻿namespace DssApiSamples.Core
{
    /// <summary>
    /// Allows samples to write messages back to the host.
    /// </summary>
    public interface IMessageWriter
    {
        /// <summary>
        /// Writes a message with the specified value and ends the line.
        /// </summary>
        void WriteLine(string message);

        /// <summary>
        /// Writes a message with the specified format string and arguments and ends the line.
        /// </summary>
        void WriteLine(string format, params object[] args);

        /// <summary>
        /// Writes a line ending.
        /// </summary>
        void WriteLine();
    }
}