﻿using System;
using System.Runtime.Serialization;

namespace DssApiSamples.Samples
{
    /// <summary>
    /// The <see cref="Exception"/> that is thrown by the <see cref="ApiUtility.Retry{T}"/> method when 
    /// the maximum number of retries has been exceeded.
    /// </summary>
    [Serializable]
    public class MaxRetriesException : Exception
    {
        #region Standard exception constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="MaxRetriesException"/> class.
        /// </summary>
        public MaxRetriesException() { }

        /// <summary>
        /// Initializes a new instance of the <see cref="MaxRetriesException"/> class with a specified error message.
        /// </summary>
        public MaxRetriesException(string message) : base(message) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="MaxRetriesException"/> class with a specified error message 
        /// and a reference to the inner exception that is the cause of this exception.
        /// </summary>
        public MaxRetriesException(string message, Exception inner) : base(message, inner) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="MaxRetriesException"/> class with serialized data.
        /// </summary>
        public MaxRetriesException(SerializationInfo info, StreamingContext context) : base(info, context) { }

        #endregion
    }
}
